<?PHP
/* 
	01-Gstebuch - Copyright 2009-2014 by Michael Lorer - 01-Scripts.de
	Lizenz: Creative-Commons: Namensnennung-Keine kommerzielle Nutzung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland
	Weitere Lizenzinformationen unter: http://www.01-scripts.de/lizenz.php
	
	Modul:		01gbook
	Dateiinfo: 	Modulspezifische Funktionen
	#fv.101#
*/

/* SYNTAKTISCHER AUFBAU VON FUNKTIONSNAMEN BEACHTEN!!!
	_ModulName_beliebigerFunktionsname()
	Beispiel: 
	if(!function_exists("_example_TolleFunktion")){
		_example_TolleFunktion($parameter){ ... }
		}
*/

// Funktion wird zentral aufgerufen, wenn das Modul gelscht werden soll
/*
RETURN: TRUE
*/
if(!function_exists("_01gbook_DeleteModul")){
function _01gbook_DeleteModul(){
global $mysqli,$mysql_tables,$modul;

$modul = $mysqli->escape_string($modul);

// MySQL-Tabellen lschen
$mysqli->query("DROP TABLE `".$mysql_tables['gb_fields']."`");
$mysqli->query("DROP TABLE `".$mysql_tables['gb_entry']."`");

// Rechte entfernen
// Nothing to be done

return TRUE;
}
}

// Drop-Down zum Sortieren der Gstebuchfelder
/*$catids			Kommaseparierter CatID-String

RETURN: <option>-Tags fr select-Feld
  */
if(!function_exists("_01gbook_FieldSortDropDown")){
function _01gbook_FieldSortDropDown($selected=1){
global $mysql_tables,$mysqli;

$return = "";
$menge = 0;
list($menge) = $mysqli->query("SELECT COUNT(*) FROM ".$mysql_tables['gb_fields']." WHERE hide = '0'")->fetch_array(MYSQLI_NUM);

for($x=1;$x<=$menge;$x++){
	if($x == $selected) $return .= "<option selected=\"selected\">".$x."</option>\n";
	else $return .= "<option>".$x."</option>\n";
	}

return $return;
}
}








// URL validieren
/*$url			URL, deren Syntax berprft werden soll

RETURN: TRUE/FALSE
  */
if(!function_exists("_01gbook_check_url")){
function _01gbook_check_url($url){

if(empty($url)) return TRUE;
else return preg_match('/^(http|https|ftp):\/\/([A-Z0-9][ A-Z0-9_]*(?:\.[A-Z0-9][A-Z0-9_]*)+):?(\d+)?\/?/i', $url);

}
}








// Angelegte Felder in einen Asso. Array einlesen
/*$where			MySQL Where-Argumente

RETURN: Assoz. Array
  */
if(!function_exists("_01gbook_getFields")){
function _01gbook_getFields($where){
global $mysql_tables,$mysqli;

$fields = array();
$list = $mysqli->query("SELECT id,name,fieldtype,parse FROM ".$mysql_tables['gb_fields']."".$where." ORDER BY sortorder,name");
while($row = $list->fetch_assoc()){
	$fields[$row['id']]['id']		= $row['id'];
	$fields[$row['id']]['name']		= stripslashes($row['name']);
	$fields[$row['id']]['fieldtype']= stripslashes($row['fieldtype']);
	$fields[$row['id']]['parse']	= stripslashes($row['parse']);
	}
	
return $fields;
}
}








// Eintrge auflisten (ACP)
/*$query			gltiger MySQL-Query fr die Eintragstabelle
  $option			Manipulator fr zustzliche / weniger Spalten

RETURN: Komplette Liste (HTML)
  */
if(!function_exists("_01gbook_getEntries_acp")){
function _01gbook_getEntries_acp($query,$option){
global $_GET,$modul,$filename,$namefield_id,$eintragsfield_id,$mysqli;

if(!isset($_GET['site'])) $_GET['site'] = 0;

$return = "<form action=\"".$filename."&amp;site=".$_GET['site']."\" method=\"post\">\n";
$return .= "<table border=\"0\" align=\"center\" width=\"100%\" cellpadding=\"3\" cellspacing=\"5\" class=\"rundrahmen trab\">

    <tr>
		<td class=\"tra\" colspan=\"2\"><b>G&auml;stebuch-Eintr&auml;ge</b></td>\n";

if($option == "free") $return .= "<td class=\"tra\" width=\"25\"><!-- Freischalten -->&nbsp;</td>\n";

$return .="		<td class=\"tra\" width=\"25\"><!-- Ansehen -->&nbsp;</td>
		<td class=\"tra\" width=\"25\"><!-- Bearbeiten -->&nbsp;</td>
		<td class=\"tra\" width=\"25\" align=\"center\"><img src=\"images/icons/icon_trash.gif\" alt=\"M&uuml;lleimer\" title=\"Kommentar l&ouml;schen\" /></td>
	</tr>\n\n";

$list = $mysqli->query($query);
while($row = $list->fetch_assoc()){
	if($option == "free" && $row['frei'] == 1)
		$colspan = " colspan=\"2\"";
	else
		$colspan = "";
	
	if(isset($row['bbc_smile_deaktiv']) && $row['bbc_smile_deaktiv'] == 0) $x = 1;
	else $x = 0;
	
	$return .= "<tr id=\"id".$row['id']."\">
	<td width=\"25\" align=\"center\"><input type=\"checkbox\" name=\"delid[]\" value=\"".$row['id']."\" /></td>
	<td".$colspan." onclick=\"modulpopup('".$modul."','show_entry','".$row['id']."','','',580,450);\" style=\"cursor: pointer;\">
		Am ".date("d.m.Y - H:i",$row['utimestamp'])."Uhr von <b>".stripslashes($row['field_'.$namefield_id])."</b> (".$row['ip'].") verfasst:<br />
		".substr(strip_tags(bb_code_comment(stripslashes($row['field_'.$eintragsfield_id]),1,$x,$x)),0,250)." [...]
	</td>\n";
	
	if($option == "free" && $row['frei'] == 0) $return .= "<td align=\"center\"><img src=\"images/icons/ok.gif\" alt=\"OK\" title=\"Eintrag freischalten\" id=\"free".$row['id']."\" onclick=\"AjaxRequest.send('modul=".$modul."&ajaxaction=freeentry&id=".$row['id']."');\" /></td>\n";
	
	$return .= "<td align=\"center\"><a href=\"javascript:modulpopup('".$modul."','show_entry','".$row['id']."','','',580,450);\"><img src=\"images/icons/icon_show.gif\" alt=\"Auge\" title=\"Eintrag ansehen\" /></a></td>
	<td align=\"center\"><a href=\"javascript:modulpopup('".$modul."','edit_entry','".$row['id']."','','',580,580);\"><img src=\"images/icons/icon_edit.gif\" alt=\"Stift+Papier\" title=\"Eintrag bearbeiten\" /></a></td>
	<td align=\"center\" nowrap=\"nowrap\"><img src=\"images/icons/icon_delete.gif\" alt=\"L&ouml;schen - rotes X\" title=\"Eintrag l&ouml;schen\" class=\"fx_opener\" style=\"border:0; float:left;\" align=\"left\" /><div class=\"fx_content tr_red\" style=\"width:60px; display:none;\"><a href=\"#foo\" onclick=\"AjaxRequest.send('modul=".$modul."&ajaxaction=delentry&id=".$row['id']."');\">Ja</a> - <a href=\"#foo\">Nein</a></div></td>
	</tr>\n\n";
	}

$return .= "</table>";	
$return .= "<p>
<input type=\"checkbox\" name=\"delselected\" value=\"1\" />
<input type=\"submit\" value=\"Ausgewhlte Eintr&auml;ge l&ouml;schen\" class=\"input\" />
Es erfolgt <b>keine</b> weitere Abfrage!
</p>";
$return .= "</form>";
	
return $return;
}
}

?>